String.prototype.gblen = function() {
	var len = 0;
	for (var i = 0; i < this.length; i++) {
		if (this.charCodeAt(i) > 127 || this.charCodeAt(i) == 94) {
			len += 2;
		} else {
			len++;
		}
	}
	return len;
};
String.prototype.gbtrim = function(len, s) {
	var str = '';
	var sp = s || '';
	var len2 = 0;
	for (var i = 0; i < this.length; i++) {
		if (this.charCodeAt(i) > 127 || this.charCodeAt(i) == 94) {
			len2 += 2;
		} else {
			len2++;
		}
	}
	if (len2 <= len) {
		return this;
	}
	len2 = 0;
	len = (len > sp.length) ? len - sp.length : len;
	for (var i = 0; i < this.length; i++) {
		if (this.charCodeAt(i) > 127 || this.charCodeAt(i) == 94) {
			len2 += 2;
		} else {
			len2++;
		}
		if (len2 > len) {
			str += sp;
			break;
		}
		str += this.charAt(i);
	}
	return str;
};

//下载器动作
function startDownload(appid, url, packageName, appName, actionCode, via) {
	try {
		if (typeof (q_download) == 'object' && typeof (q_download.doGCDownloadAction) == 'function') {
			var json = '{"appid":'+appid+',"url":"'+url+'","packageName":"'+packageName+'","actionCode":'+actionCode+',"via":"'+via+'","appName":"'+appName+'","dType":0,"notifyKey":"_'+appid+'","actionType":900,"gf":"gf","from":"gamecenter"}';
			q_download.doGCDownloadAction(json);
		}	
	} catch (e) {
		GCB.showalert(e.message);
	}
}

//注册下载器回调函数
function registerDownloadCallBack(callback) {
	try{
		if (typeof (q_download) == 'object' && typeof (q_download.registerDownloadCallBackListener) == 'function') {
			q_download.registerDownloadCallBackListener(callback);
		}
	} catch (e) {
		GCB.showalert(e.message);
	}
}

//阴影显示告警
function showWarning(str) {
	if (typeof (GCApi) == 'object' && typeof (GCApi.showWarningToast) == 'function') {
		GCApi.showWarningToast(str);
	}
}

//重设缓存过期时间
function resetCacheTime(){
	//清空批量接口缓存
	var appid_batch = GCB._getCache('appid_batch');
	var uin = GCB._getUin();
	if (appid_batch && uin){
		var tkey = 'GC_batch_' + uin + '_' + appid_batch + '_friend_time';
		GCB._setCache(tkey, 0);
		var appids = appid_batch.split('|');
		if (appids) {
			for(var i=0; i<appids.length ; i++){
				var tkey_rank = 'GC_' + uin + '_' + appids[i] + '_rank_time';
				var tkey_friend = 'GC_' + uin + '_' + appids[i] + '_friend_time';
				GCB._setCache(tkey_rank, 0);
				GCB._setCache(tkey_friend, 0);
			}
		}
	}		
}

var GCB = {
	slip:null,
	feeds:{
		pageNum: 0,//页数， 每次请求拉20条数据， 最多可以拉50条数据，分3次请求
		perNum: 20,
		maxNum: 50,
		currentime: null,
        maxPageNum: 0,
        inQuery: false
	},
	
	showalert:function(str){
		//alert(str);
	},

	//判断自动启动游戏
	autoStart: function(appid){
		try{
			var that = GCB, pf = that._getUrlParm('pf');
			if (pf && pf == 'invite' && that.isAppInstalled(appid)) {
				that.startApp(appid);
			}
		} catch(e) {}
	},
	
	//初始化滑动层
	initDetail: function(){
		ai.hideUrl();
		var bar_list_ul = ai.i("bar_list_ul"),
			bar_list    = ai.i("bar_list"),
			minus       = 0,
			padTop = ai.wh() - 186;
			bar_list.style.height =  ai.wh() - minus +"px";
			ai.i("bar_list_ul").setAttribute('style','padding-top:'+ padTop +'px;');
			
		GCB.slip = slip('px',bar_list_ul,{
			perfect: true
		});
		ai.resize(function() {
			ai.hideUrl();
			bar_list.style.height = ai.wh() - minus +"px";
			GCB.slip.refresh();
		});		
	},
	
	//重置滑动层
	resizeDetail:function(){
		GCB.slip.refresh();
	},
	
	//显示好友排行
	showRank: function(appid,rCache){
		var json = eval('('+rCache+')');
		if (json.ret != '0' || parseInt(json.total,10) <= 0)	return;
		var items = json.myitems, _length = items.length, rankHtml=[], that = GCB, item=null;
		_length = _length < 11 ? _length : 10;
		var selfRank = json.self_rank ?  parseInt(json.self_rank.rank,10) : 0;
		if (_length < 4){
			//如果少于4个人不显示领奖台
			for(var k=0;k<_length;k++){
				item = items[k];
				rankHtml.push(that._getCommonRankDetail(item,selfRank));
			}
		}else{
			rankHtml.push(that._getTopThreeDetail(items[0],items[1],items[2]));	
			for(var k=3;k<_length;k++){
				item = items[k];
				rankHtml.push(that._getCommonRankDetail(item,selfRank));
			}
		}
		document.getElementById('rank'+appid).innerHTML = rankHtml.join(' ');
		document.getElementById('rankBox'+appid).style.display = '';
	},
	
	//列表显示排行
	_getCommonRankDetail: function(item,selfRank){
		var rankClass = (!selfRank || (parseInt(item.rank,10) != selfRank)) ? '' : 'class="greyBg"';
		return ['<li ',rankClass,'><dl class="rankList"><dd class="fl n1">',item.rank,'</dd>','<dt class="fl"><img src="',
				item.figureurl_qq,'40" class="perImg1" /></dt>','<dd class="fl">',
				item.nickname,'</dd>','<dd class="fr num">',
				(parseInt(item.data) > 0 ? item.data : '本周暂无分数'),'</dd></dl></li>'].join('');
	},
	
	//前三名领奖台显示
	_getTopThreeDetail: function(item1,item2,item3){
		return['<li><dl class="fl rankCon"><dt class="tc"><img src="',
			   item2.figureurl_qq,
			   '100" class="perImg" /><i class="db hexagon">2</i></dt><dd class="tcH">',
			   item2.nickname,
			   '</dd><dd class="num1">',
			   item2.data,
			   '</dd></dl><dl class="fl rankCon"><dt class="tc1"><img src="',
			   item1.figureurl_qq,
			   '100" class="perImgOne" /><i class="db hexagon b2">1</i></dt><dd class="tcH">',
			   item1.nickname,
			   '</dd><dd class="num2">',
			   item1.data,
			   '</dd></dl><dl class="fl rankCon"><dt class="tc"><img src="',
			   item3.figureurl_qq,
			   '100" class="perImg" /><i class="db hexagon b3">3</i></dt><dd class="tcH">',
			   item3.nickname,
			   '</dd><dd class="num3">',
			   item3.data,
			   '</dd></dl></li>'].join('');
	},
	
	//获取好友排行
	getFriendRankByAppid: function(appid){
		try{
			if (!appid)	appid = window['CURRENT_APPID'];
			if (!appid)	{
				return;
			}
			
			var sid = GCB._getSid();
			if (!sid) {
				return;
			}
	
			var uin = GCB._getUin(),
				fkey = 'GC_' + uin + '_' + appid + '_rank_info',
				tkey = 'GC_' + uin + '_' + appid + '_rank_time' ,
				fCache = GCB._getCache(fkey),
				tCache = GCB._getCache(tkey),
				now =new  Date().getTime();
            if (uin && fCache && tCache){
				//缓存时间范围内
				if(Math.abs(now - parseInt(tCache,10)) < GCD.cacheTime){
					//显示好友
                    GCB.showRank(appid,fCache);
					GCB.resizeDetail();
					return;
				} 
			}

			var xhr = GCB.createXMLHttp();
			window['time_getrank'] = new Date();
			xhr.open("GET", 'http://gamecenter.qq.com/game/get_achieve?sort=3&type=3&tt=1&sid='+encodeURIComponent(sid)+'&appid='+appid, true);
			xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			xhr.onreadystatechange = function() {
		        if (xhr.readyState == 4) {
		            if (xhr.status >= 200 && (xhr.status < 300 || xhr.status == 304)) {
		            	var jsonStr = xhr.responseText;
		            	var jsobObject = eval('('+jsonStr+')');
		            	if (jsobObject.ret == '0'){
							var that = GCB, _appid = jsobObject.appid, uin = that._getUin(),
                                fkey = 'GC_' + uin + '_' + _appid + '_rank_info',
                                tkey = 'GC_' + uin + '_' + _appid + '_rank_time',
                                currentime = new Date().getTime() + "";
							that._setCache(fkey,jsonStr);
							that._setCache(tkey,currentime);
							that.showRank(_appid,jsonStr);
                            var speed_d1 = new Date();
                            that._speed("7718","127","13","1",(speed_d1-window['time_getrank']));
		            	}
		            	GCB.resizeDetail();
		            	return;
		            }
		        }
	    	};
	    	xhr.setRequestHeader("If-Modified-Since", "0");
	    	xhr.send(null);

		}catch(e){
		
		}
	},
	
	//显示好友信息
	showQQFriend:function(appid,jsonStr){
		var json = eval('('+jsonStr+')');
		if (json.ret != '0' || parseInt(json.total,10) <= 0)	return;
		var items = json.items, 
			nickName = items.length > 1 ? items[1].nickname : items[0].nickname;
			nickName = nickName.gbtrim(9,'...'),
			desc = '';
		var self_rank = json.self_rank ? parseInt(json.self_rank.rank,10) : 0;
		var self_score = json.self_rank ? parseInt(json.self_rank.score,10) : 0;
		var pre_rank = json.pre_rank ? parseInt(json.pre_rank.rank,10) : 0;
		var pre_score = json.pre_rank ? parseInt(json.pre_rank.score,10) : 0;
		var pre_name = json.pre_rank ? json.pre_rank.nickname:'';
		pre_name = pre_name.gbtrim(9,'...');
		if (document.getElementById("friend_num_"+appid)){
			if (GCB.isHomePage){
				//列表页
				if (GCB.isAppInstalled(appid) && self_rank){
					if (self_rank == 1 && self_score > 0){
						//第一名且有分数
						desc = '独孤求败，<span class="fc">你</span>已经是第<span>1</span>名！';
					}else if (pre_rank && pre_score > 0 && self_score > 0) {
						//前一名有分数
						var scorediff = pre_score - self_score;
						if (scorediff > 10000){
							scorediff = Math.round(scorediff/10000);
							scorediff = scorediff + '万';
						}
						desc = '<span class="fc">'+ pre_name +'</span>排在第<span>'+pre_rank+'</span>名，再玩'+ scorediff + '分超越Ta！';
					}else if (self_score == 0){
						desc = '<span class="fc">你</span>本周还没有分数，快去玩一把';
					}
					desc =desc + '<br/> <span class="fc">'+nickName+'</span>等<span>'+json.total+'</span>位好友已在玩。';
				}else{
					desc = GCD[appid]['slogan']+'<br/> <span class="fc">'+nickName+'</span>等<span>'+json.total+'</span>位好友已在玩。';
				}
				document.getElementById("friend_num_"+appid).innerHTML =  desc;
			}else{
				//详情页
				if (GCB.isAppInstalled(appid) && self_rank){
					if (self_rank == 1 && self_score > 0){
						//第一名
						desc = '独孤求败，<span class="fc">你</span>已经是第<span>1</span>名！';
					}else if (pre_rank && pre_score > 0  && self_score > 0) {
						//前一名有分数
						var scorediff = pre_score-self_score;
						if (scorediff > 10000){
							scorediff = Math.round(scorediff/10000);
							scorediff = scorediff + '万';
						}
						desc = '<span class="fc">'+ pre_name +'</span>排在第<span>'+pre_rank+'</span>名，再玩'+ scorediff + '分超越Ta！';
					}else if (self_score == 0) {
						desc = '<span class="fc">你</span>本周还没有分数，快去玩一把';
					}
					desc =desc + '<br/> <span class="fc">'+nickName+'</span>等<span>'+json.total+'</span>位好友已在玩。';
					document.getElementById("friend_num_"+appid).setAttribute('class','textP1');
				}else{
					desc = '<span class="fc">'+nickName+'</span>等<span>'+json.total+'</span>位好友已在玩。';
					document.getElementById("friend_num_"+appid).setAttribute('class','textP3');
				}
				document.getElementById("friend_num_"+appid).innerHTML =  desc;
			}
		}
		for (var i=0;i<items.length && i<6;i++) {
			var img = document.getElementById('friendpic'+i);
			if (img){
				img.setAttribute('src', items[i].figureurl_qq+'40');
				img.style.display = "";
			}
		}
	},
	
	//拉取好友信息
	getQQFriendByAppid:function(appid,isHomePage){
        try{
            GCB.isHomePage = isHomePage;
            if (!appid)	appid = window['CURRENT_APPID'];
            if (!appid)	return;
            var sid = GCB._getSid();
            if (!sid) return;

            var uin = GCB._getUin(),
                fkey = 'GC_' + uin + '_' + appid + '_friend_info',
                tkey = 'GC_' + uin + '_' + appid + '_friend_time',
                fCache = GCB._getCache(fkey),
                tCache = GCB._getCache(tkey),
                now = new Date().getTime();
            if (uin && fCache && tCache){
                //缓存时间范围内
                if(Math.abs(now - parseInt(tCache,10)) < GCD.cacheTime){
                    //显示好友
                    GCB.showQQFriend(appid,fCache);
                    return;
                }
            }
            window['time_getfriend'] = new Date();
            var xhr = GCB.createXMLHttp();
            xhr.open("GET", 'http://gamecenter.qq.com/appfriends/get?sid='+encodeURIComponent(sid)+'&tt=1&appid='+appid, true);
            xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
            xhr.onreadystatechange = function() {
                if (xhr.readyState == 4) {
                    if (xhr.status >= 200 && (xhr.status < 300 || xhr.status == 304)) {
                        var jsonStr = xhr.responseText;
                        var jsobObject = eval('('+jsonStr+')');
                        if (jsobObject.ret == '0'){
                            var that = GCB, _appid = jsobObject.appid, uin = that._getUin();
                            that._setCache('GC_' + uin + '_' + _appid + '_friend_info',jsonStr);
                            that._setCache('GC_' + uin + '_' + _appid + '_friend_time',(new Date().getTime()+""));
                            that.showQQFriend(_appid,jsonStr);
                            var currentime = new Date();
                            that._speed("7718","127","11","1",(currentime - window['time_getfriend']));
                        }
                        return;
                    }
                }
            };
            xhr.setRequestHeader("If-Modified-Since", "0");
            xhr.send(null);
                
        } catch (e){
            GCB.showalert(e.message);
        }

	},
	
	createXMLHttp: function () {
	    var e = !1;
	    try {
	        e = new ActiveXObject("Msxml2.XMLHTTP");
	    } catch (t) {
	        try {
	            e = new ActiveXObject("Microsoft.XMLHTTP");
	        } catch (n) {
	            e = !1;
	        }
	    }
	    return !e && typeof XMLHttpRequest != "undefined" && (e = new XMLHttpRequest()), e;
	},
	
	//设置最新的下载地址
	setDownloadURL:function(appid){
		if (document.getElementById('btn'+appid) && GCD && GCD[appid] && GCD[appid]['url']){
			document.getElementById('btn'+appid).setAttribute('href',GCD[appid]['url']);
		}	
	},
	
	//判断应用是否安装
	isAppInstalled: function(appid){
		if (typeof(QQApi) == 'object' && typeof(QQApi.isAppInstalledBatch) == 'function' && GCD[appid]['pkgName']) {
			var batchRet = QQApi.isAppInstalledBatch(GCD[appid]['pkgName']);
			if(batchRet && batchRet != '0' && batchRet.split('|')[0] == '1'){
				return true;
			}
		}
		return false;
	},	
	
	//获取URL参数
	_getUrlParm: function(name){
		var reg = new RegExp("(^|&)"+ name +"=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
		var r = window.location.search.substr(1).match(reg);  //匹配目标参数
		if (r!=null) return unescape(r[2]); return null;	  //返回参		
	},
	
	//获取UIN
	_getUin: function(){
		if (typeof(GCApi)=='object' && typeof (GCApi.getUin) == 'function'){
			return GCApi.getUin();
		}	
		return null;
	},
	
	//获取SID
	_getSid: function(){
		var sid = GCB._getUrlParm("sid");
		if (!sid && typeof(GCApi) == 'object' && typeof(GCApi.getSid) == 'function') {
			sid = GCApi.getSid();
		}
		return sid;
	},
		
	_setCache:function(key, value){
		if (window.localStorage){
			window.localStorage.setItem(key, value);
			return true;
		}
		return false;
	},

	_getCache:function(key){
		if (window.localStorage){
			return window.localStorage.getItem(key);
		}
		return false;
	},

    _speed:function(flag1,flag2,flag3,id,time){
        try{
            var speedImg = new Image();
            if (Math.random() < 0.5){
                speedImg.src = "http://isdspeed.qq.com/cgi-bin/r.cgi?flag1="+flag1+"&flag2="+flag2+"&flag3="+flag3+"&"+id+"="+time;
            }
        }catch(e){
            GCB.showalert(e.message);
        }
    },

	//从网络中获取OPENID, 应该在列表页和详情页加载时调用
	getOpenIdNetwork: function(appidArray){
		if(!appidArray){
			return;
		}
		var that = GCB;
		var appids = '';
 		//判断缓存
		var uin = that._getUin();
		if (uin){
			for (var i=0; i<appidArray.length; i++) {
				var appid = appidArray[i];
				var key = 'GC_'+uin+'_'+appid+'_openid';
				if (GCB._getCache(key)){
					continue;
				}
				
				if(appids == '')
					appids = appid;
				else
					appids = appids + ","+appid;
			}
		}
		
		if (appids == '')
			return;
		//缓存不存在，从网络拉取
		var speed_d0 = new Date();
		window['openid_speed_d0'] = speed_d0;
		//后台拉取openid
		try{
			var sid = GCB._getSid();
			if (sid){
				var url = "http://gamecenter.qq.com/common/get/openid?appid="+encodeURIComponent(appids)+"&sid="+encodeURIComponent(sid);
				var xhr = GCB.createXMLHttp();
				xhr.open("GET", url, true);
				xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
				xhr.onreadystatechange = function() {
					if (xhr.readyState == 4) {
						//上报OPENID接口时间	
						var speed_d1 = new Date();
						var _speed_d0 = window['openid_speed_d0'];
						GCB._speed("7718","127","10","1",(speed_d1 - _speed_d0));
						if (xhr.status >= 200 && (xhr.status < 300 || xhr.status == 304)) {
							var jsonStr = xhr.responseText;
							var jsobObject = eval('('+jsonStr+')');
							if (jsobObject.ret == '0'){
								var that = GCB, _uin = that._getUin();
								var items = jsobObject.items;
								if (items) {
									for(var i=0; i<items.length; i++) {
										var _openid = items[i].openid;
										var _appid = items[i].appid;
										that._setCache('GC_'+_uin+'_'+_appid+'_openid', _openid);
									}
								}
							}
							return;
						}
					}
				};
				xhr.setRequestHeader("If-Modified-Since", "0");
				xhr.send(null);
			}
		}catch(e){
			GCB.showalert(e.message);
		}
	},
	
	//从缓存中取openid
	getOpenIdCache:function(appid) {
		if(!appid){
			return '';
		}
		var that = GCB, openid = '';
 		//判断缓存
		var uin = that._getUin();
		if (uin){
			var key = 'GC_'+uin+'_'+appid+'_openid';
			openid = that._getCache(key);
			if(openid){
				return openid;
			}
		}
		return openid;
	},
	
	//启动应用
	startApp: function(appid){
		
		if(typeof(QQApi) != 'object' || !GCD[appid]['pkgName']){
			return;
		}	
		if(!GCB.isAppInstalled(appid)){
			showWarning('系统无法检测到你已安装此游戏！');
			setTimeout(function(){window.location.reload();}, 1500);
			return;
		}
		
		try{
			var openid = GCB.getOpenIdCache(appid);
			if (!openid || openid == '0' || openid == ''){
				QQApi.startAppWithPkgName(GCD[appid]['pkgName']);
			}else{
				QQApi.startAppWithPkgNameAndOpenId(GCD[appid]['pkgName'] ,openid);
			}
		}catch(e){
			
		}	
		return;
	},
	
	//小红点
	popRedDot: function(){
		var sid = GCB._getSid();
	    if (!sid) return;
	    var t = GCB.createXMLHttp();
	    t.open("GET", "http://gamecenter.qq.com/redbit/set?&tt=1&sid=" + encodeURIComponent(sid), true), 
	    t.setRequestHeader("Content-Type", "application/x-www-form-urlencoded"), t.onreadystatechange = function() {
	        if (t.readyState == 4) {
	            if (t.status >= 200 && (t.status < 300 || t.status == 304)) {
	            	return;
	            }
	            return;
	        }
	    }, t.setRequestHeader("If-Modified-Since", "0"), t.send(null);
	},
	
	 //获取新消息数目
	getNewFeedsNum : function(){
		var sid = GCB._getSid();
		if(!sid){
			return;
		}

		var abortTimeout,_xhrTimeout, xhr = new XMLHttpRequest();
		xhr.open("GET", "http://gamecenter.qq.com/game/feeds/get?sid="+encodeURIComponent(sid), true);
		xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		xhr.setRequestHeader("If-Modified-Since", "0");
        window["time_newFeedNum"] = new Date();
        xhr.onreadystatechange = function() {
			if(xhr.readyState == 4) {
				clearTimeout(abortTimeout);
				if((xhr.status >= 200 && xhr.status < 300) || xhr.status == 304){
					var that = GCB,
						json = eval('(' + xhr.responseText + ')');
                    that._speed("7718","127","15","4",(new Date()-window["time_newFeedNum"]));
                    if(json.ret != 0 || (json.ret == 0 && parseInt(json.feeds_num,10) < 1)) {
						return;
					}
					document.getElementById('feeds_from_faceUrl').setAttribute("src",(json.sender_face ? json.sender_face : "http://qlogo3.store.qq.com/qzone/"+json.feeds_f+"/"+json.feeds_f+"/100"));
					document.getElementById('feeds_from_faceUrl').style.display = "";
					document.getElementById('feeds_num').innerHTML =  json.feeds_num+"条新消息";
					document.getElementById("feeds_num").style.display = "";

				}
			}
		};
		abortTimeout = setTimeout((function() {
			return function(xhr){
			xhr.onreadystatechange = {};
			xhr.abort();
			};
		}), 5000);
		xhr.send(null);
	},

	//拉去feeds消息，每次拉只拉取20条数据
	getFeeds: function(pageid){
        var that = GCB, sid = that._getSid();
        if (!sid){
			return;
		}
        that.feeds.inQuery = true;
		that.feeds.pageNum = pageid;//从0开始

        //先加载缓存记录
        if (pageid == 0){
            var uin = that._getUin(), feedsCache = that._getCache("GC_FEEDS_"+uin);
            if(feedsCache && document.getElementById("tooltip").getAttribute("status") == "loading"){
                document.getElementById("message_center").innerHTML =  feedsCache;
            }
        }

		var perNums = that.feeds.perNum,
		beginnum = perNums * pageid,
		endnum = perNums * (pageid+1) - 1,
		data =  {
			"req_types":"40",
			"beginnum":beginnum,
			"endnum": endnum,
			'sid': sid};

		var url = "http://gamecenter.qq.com/game/feeds/get_detail?" + that.serializeParameters(data);
		var abortTimeout, xhr = new XMLHttpRequest();
		xhr.open("GET", url, true);
		xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		xhr.setRequestHeader("If-Modified-Since", "0");
        window["time_feeds"] = new Date();
		xhr.onreadystatechange = function() {
			clearTimeout(abortTimeout);
			if (xhr.readyState == 4) {
				var that = GCB;
                that._speed("7718","127","15","2",(new Date()-window["time_newFeedNum"]));
                if ((xhr.status >= 200 && xhr.status < 300) || xhr.status == 304){
                    that.showFeeds(xhr.responseText);
                    //拉取消息成功，隐藏 正在加载...
                    that.showTooltip("success");
                    //更新FEEDS缓存
                    if (that.feeds.pageNum == 0){
                        that._setCache("GC_FEEDS_"+that._getUin(),document.getElementById("message_center").innerHTML);
                    }
				}else{
                    that.showTooltip(!xhr.status ? "neterror":"ajaxerror");
				}
                that.feeds.inQuery = false;
				return;
			}
		};
		abortTimeout = setTimeout(function() {
			return function(xhr){
				xhr.onreadystatechange = {};
				xhr.abort();
                GCB.showTooltip("neterror");
                GCB.feeds.inQuery = false;
			};
		}, 10000);
		try{
			xhr.send(null);
		}catch (e){
            GCB.showTooltip("ajaxerror");
		}
	},
    lazyLoadImage: function(){
        var images = document.getElementsByTagName("img"), image = null;
        if (images.length == 0){
            return;
        }
        var offsetPage = window.pageYOffset ? window.pageYOffset : window.document.documentElement.scrollTop,
            offsetWindow = offsetPage + Number(window.innerHeight ? window.innerHeight : document.documentElement.clientHeight),
            postPage;
        for (var i = 0; i < images.length; i++) {
            image = images[i];
            if (!image.getAttribute("lazyImg")) {
                continue;
            }

            image.setAttribute("src",image.getAttribute("lazyImg"));
            image.onload = image.onerror = function(){
                this.removeAttribute("lazyImg");
                this.onload = this.onerror = null;
            }
        }
    },

    showTooltip: function(status){
        var tooltip = document.getElementById("tooltip"),
            currentStatus = tooltip.getAttribute("status");
        tooltip.setAttribute("status",status);
        if (status == "success"){
            if (currentStatus == "nofeeds"){
                return;
            }
            if (currentStatus == "refreshing") {
                tooltip.innerHTML = '<i class="rInco db spr"></i>完成刷新...';
                setTimeout(function(){
                    tooltip.style.display = "none";
                    tooltip.setAttribute("status","refreshed");
                },1500);
                return;
            }
            tooltip.style.display = "none";
            tooltip.setAttribute("status","success");
            return;
        }
        if (status == "nofeeds"){
            document.getElementById("message_center").innerHTML = "";
            tooltip.innerHTML = '暂无消息';
            tooltip.style.display = "";
            tooltip.setAttribute("status","nofeeds");
            return;
        }
        if (status == "refreshing"){
            tooltip.innerHTML = '<img src="../images/load.gif" />刷新中...';
            tooltip.style.display = "";
            tooltip.setAttribute("status","refreshing");
            return;
        }
        if (status == "loading"){
            tooltip.innerHTML = '<img src="../images/load.gif" />正在加载...';
            tooltip.style.display = "";
            tooltip.setAttribute("status","loading");
            return;
        }
        if (status == "neterror"){
            tooltip.innerHTML = '当前网络不可用，请检查你的网络设置';
            tooltip.style.display = "";
            tooltip.setAttribute("status","neterror");
            //点击刷新
            var refresh = function(e){
                GCB.showTooltip("loading");
                GCB.getFeeds(0);
                document.getElementById("tooltip").removeEventListener("touchstart",refresh, false);
            };
            tooltip.addEventListener("touchstart",refresh,false);
            return;
        }
        if (status == "ajaxerror"){
            tooltip.innerHTML = '糟糕出错了，请点击此处重新尝试';
            tooltip.style.display = "";
            tooltip.setAttribute("status","ajaxerror");
            //点击刷新
            var refresh = function(e){
                GCB.showTooltip("loading");
                GCB.getFeeds(0);
                document.getElementById("tooltip").removeEventListener("touchstart",refresh, false);
            };
            tooltip.addEventListener("touchstart",refresh,false);
            return;
        }
        return;
    },

	showFeeds: function(jsonStr){
		var json = eval('('+jsonStr+')'), that = GCB;


        if (json.ret != 0){
            that.showTooltip("ajaxerror");
            return;
        }

        if (json.total == 0){
            that.showTooltip("nofeeds");
            return;
        }
        
		var maxNum = that.feeds.maxNum,
		perNum = that.feeds.perNum,
			totalNum = parseInt(json.total,10) <= maxNum ? parseInt(json.total,10) : maxNum ,
			maxPageNum = parseInt(Math.ceil(totalNum/that.feeds.perNum),10) - 1,
			feedList = json.data,
			_length = feedList.length,
			feedHtml = [],
			currentPage = that.feeds.pageNum;
		that.feeds.currentime = Math.floor(json.current_time/1000);
        that.feeds.maxPageNum = maxPageNum;
		for(var k = 0;k < _length; k++ ){
			feedHtml = feedHtml.concat(that.generateFeedContent(feedList[k]));
		}
        if (that.feeds.pageNum == 0){
            document.getElementById("message_center").innerHTML = feedHtml.join("");
        }else{
            document.getElementById("message_center").insertAdjacentHTML("beforeend",feedHtml.join(""));
        }

        if (currentPage < maxPageNum){
            document.getElementById("bottom_statusBar").style.display = "";
        }else{
            document.getElementById("bottom_statusBar").style.display = "none";
        }
        //加载头像
        that.lazyLoadImage();
	},

	generateFeedContent: function(feed){
        var status =  feed.requeststate == 0 ? 'class="bg"' :  '',
            feedDesc =  feed.itemdesc.replace("{nickname}",("<strong>"+ feed.sendnick +"</strong>")),
            sendTime = Math.floor(feed.sendtime / 1000),
            alias = feed.alias;
        return ['<dd ',status,'><img src="../images/defaultHead.png" lazyImg="',feed.sender_face,'" class="perListImg fl" /><p class="fl"><span class="infoT db">',feedDesc,
            '</span><span class="db"><i class="time">',GCB.timestamp2DateString(sendTime,GCB.feeds.currentime),'</i>',alias,'</span></p><a href="javascript:GCB.startApp(',
            feed.appid,');" class="fr db iMt"><i class="arrow spr fr db"></i></a></dd>'];
	},

	serializeParameters: function(parameters, character) {
		var parameter, serialize;

		if (character == null) {
			character = "";
		}
		serialize = character;
		for (parameter in parameters) {
			if (parameters.hasOwnProperty(parameter)) {
				if (serialize !== character) {
					serialize += "&";
				}
				serialize += "" + (encodeURIComponent(parameter)) + "=" + (encodeURIComponent(parameters[parameter]));
			}
		}
		if (serialize === character) {
			return "";
		} else {
			return serialize;
		}
	},

	timestamp2DateString: function(timestamp, currentimestamp){
		var today = new Date(currentimestamp);
		var date = new Date(timestamp);
		var days = parseInt((new Date(today.getFullYear(), today.getMonth(),today.getDate(),0, 0,0,0) -  new Date(date.getFullYear(), date.getMonth(),date.getDate(),0, 0,0,0))/(24*60*60*1000),10);
		var month = date.getMonth();
		var day = date.getDate();
		var hour = date.getHours();
		var minute = date.getMinutes();
		month = month + 1;
		if (hour < 10)
		{
			hour = '0' + hour;
		}
		if (minute < 10)
		{
			minute = '0' + minute;
		}

		if (days == 0){
			return  hour + ":" + minute;
		}else if(days == 1){
			return  "昨天"+hour + ":" + minute;
		}else if (days == 2){
			return  "前天"+hour + ":" + minute;
		}else{
			return  month + "月" + day + "日 " + hour + ':' + minute;;
		}
	},

    scrollLoad: function(){
        window.onscroll = function () {
            var e = document.getElementById("bottom_statusBar"), that = GCB;
            if (e.style.display == "none" || that.feeds.inQuery === true || that.feeds.pageNum >= that.feeds.maxPageNum){
                return;
            }
            var offsetPage = window.pageYOffset ? window.pageYOffset : window.document.documentElement.scrollTop,
                offsetWindow = offsetPage + Number(window.innerHeight ? window.innerHeight : document.documentElement.clientHeight);
            var postPage = e.getBoundingClientRect().top + window.document.documentElement.scrollTop + window.document.body.scrollTop;
            if ((postPage > offsetPage && postPage < offsetWindow) ) {
                that.getFeeds(that.feeds.pageNum + 1);
            }
        };
    }
};